<?php 
class stf_adsense extends WP_Widget {
	public function __construct() {	

		$widget_ops = array(
			'classname' => 'stf-adsense',
			'description' => esc_html__( 'A widget to display ads.', 'wfnews' ) 
		);

		parent::__construct(
			'wfnews',
			esc_html__( 'WFNews Google Adsense', 'wfnews' ),
			$widget_ops
		);

			$this->alt_option_name = 'stf_adsense';	
			

			$this->settings_key = "stf_adsense";

			
			// Default widget options
			$this->widget_defaults = array(
				'title' => '',
				'slot' => '',
				'channel'	=> '',
				'type' => 'banner',
				'content' => 'text_image',
				'adsense_id' => ''
			);
			
			// Ad content types
			$this->content_types = array( 'text', 'image', 'text_image' );
			
			// Include ad type array
			require_once("adsense-ad-types.php");
			$this->ad_types = $ad_types;
			
						
			if( !is_admin() ){
				wp_enqueue_style( 'wfnews', WFNEWS_MODULES_DIR . "css/adsense-widget.css", false, "1.0", "all");	
			}						
    }

    function widget($args, $instance) {		
	
		extract( $args );
		$widget_options = wp_parse_args( $instance, $this->widget_defaults );
		extract( $widget_options, EXTR_SKIP );
		

		
		$msg = '';
		
		if( empty( $adsense_id ) ){
			echo "";

		} else {
			
			if(!empty($slot) && $slot != ""){
				$ad_slot = ' google_ad_slot = "'.$slot.'"; ';
			} else {
				$ad_slot = "\n\t /* ad slot is empty */ ";
				$ad_colors = "";
				
				if( !empty( $settings['google_color_border'] ) ){ $ad_colors .= "\n\tgoogle_color_border = \"".$settings['google_color_border']."\";"; }
				if( !empty( $settings['google_color_link'] ) ){ $ad_colors .= "\n\tgoogle_color_link = \"".$settings['google_color_link']."\";"; }
				if( !empty( $settings['google_color_url'] ) ){ $ad_colors .= "\n\tgoogle_color_url = \"".$settings['google_color_url']."\";"; }
				if( !empty( $settings['google_color_text'] ) ){ $ad_colors .= "\n\tgoogle_color_text = \"".$settings['google_color_text']."\";"; }
				if( !empty( $settings['google_color_bg'] ) ){ $ad_colors .= "\n\tgoogle_color_bg = \"".$settings['google_color_bg']."\";"; }
				
				if(empty($ad_colors)){
					$ad_colors = "/* adcolors not defined */";
				} 
			}
				
			if(!empty($channel)){
				$ad_channel = ' google_ad_channel = "'.$channel.'"; ';
			} else { $ad_channel = "/* ad channel is empty */"; }
			
			$ad_type = ' google_ad_type = "'.$content.'"; ';
			
			$ad = $this->ad_types[$type];
			$ad_class = $ad['classname'];
			$ad_size = $ad['script'];

			
			
				echo $before_widget; //escaped already
				if (!empty($instance['title']))
					echo $before_title . apply_filters('widget_title', $instance['title']) . $after_title; //escaped already
			
				// Echo adsense code
				echo "<div class=\"adsense ".$ad_class."\">";
				
				// Script part
				echo "<script type=\"text/javascript\">
		google_ad_client = \"".$adsense_id."\";";
				echo "\n\t" . $ad_size;
				echo "\n\t" . $ad_slot;
				echo "\n\t" . $ad_channel;
				echo "\n\t" . $ad_type;
				echo "\n\t" . $ad_colors;
				echo "\n\t 
		</script>
		
		<script type=\"text/javascript\"
		src=\"http://pagead2.googlesyndication.com/pagead/show_ads.js\">
		</script>"; 
		
				echo "</div>";
				echo $after_widget; //escaped already
	
			  		
		}
    }

    function update($new_instance, $old_instance) {				
        return $new_instance;
    }

    function form($instance) {  
		
		$widget_options = wp_parse_args( $instance, $this->widget_defaults );
		extract( $widget_options, EXTR_SKIP );
		
		if (!empty($instance['title'])) 
			$title = esc_attr($instance['title']);
			
		if (!empty($instance['type'])):
			$type = $instance['type'];
		else:
			$type = null;
		endif;
		
		if(empty($adsense_id)){
			$adsense_id = get_option('shailan_adsense_id', '');
		}
		
		?>
		
		<p><label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php esc_html_e('Title :', 'wfnews'); ?>  <input class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></label><br />

		<p><label for="<?php echo esc_attr($this->get_field_id('adsense_id')); ?>"><?php esc_html_e('Adsense id :', 'wfnews'); ?> <input class="widefat" id="<?php echo esc_attr($this->get_field_id('adsense_id')); ?>" name="<?php echo esc_attr($this->get_field_name('adsense_id')); ?>" type="text" value="<?php echo esc_attr($adsense_id); ?>" placeholder="ca-pub-xx"/></label><br />
		
		
		<p><label for="<?php echo esc_attr($this->get_field_id('type')); ?>"><?php esc_html_e('Ad type:', 'wfnews'); ?>  <select name="<?php echo esc_attr($this->get_field_name('type')); ?>" id="<?php echo esc_attr($this->get_field_id('type')); ?>" >
		 <?php 
		  foreach ($this->ad_types as $key=>$ad) {  
			$option = '<option value="'. esc_attr($ad['key']) .'" '. ( $ad['key'] == $type ? ' selected="selected"' : '' ) .'>';
			$option .= esc_attr($ad['name']);
			$option .= '</option>\n';
			echo $option; //escaped already
		  }
		 ?>
		</select></label><br /> 
		<small></small></p>	
		
		<p><label for="<?php echo esc_attr($this->get_field_id('slot')); ?>"><?php esc_html_e('Slot ID (Optional):', 'wfnews'); ?>  <input class="widefat" id="<?php echo esc_attr($this->get_field_id('slot')); ?>" name="<?php echo esc_attr($this->get_field_name('slot')); ?>" type="text" value="<?php echo esc_attr($slot); ?>" /></label><br />
		<small><?php esc_html_e('Slot id for the ad you created.( Eg. 1234567890 )', 'wfnews'); ?></small><br /> 
			
		<p><label for="<?php echo esc_attr($this->get_field_id('channel')); ?>"><?php esc_html_e('Channel ID (Optional):', 'wfnews'); ?>  <input class="widefat" id="<?php echo esc_attr($this->get_field_id('channel')); ?>" name="<?php echo esc_attr($this->get_field_name('channel')); ?>" type="text" value="<?php echo esc_attr($channel); ?>" /></label><br /> 
		<small><?php esc_html_e('Your channel id.( Eg. 1234567890 )', 'wfnews'); ?></small><br /> 
		
		<p><label for="<?php echo esc_attr($this->get_field_id('content')); ?>"><?php esc_html_e('Content type :', 'wfnews'); ?>  <select name="<?php echo esc_attr($this->get_field_name('content')); ?>" id="<?php echo esc_attr($this->get_field_id('content')); ?>" >
		 <?php 
		  foreach ( $this->content_types as $content_type ) {  
			$option = '<option value="'. $content_type .'" '. ( $content_type == $content ? ' selected="selected"' : '' ) .'>';
			$option .= $content_type;
			$option .= '</option>\n';
			echo $option;
		  }
		 ?>
		</select></label><br/> 
	 </p>	
					
		<?php
    }

} // class stf_adsense 