<?php
/******************
Google Ad Types
******************/
if ( ! function_exists( 'wfnews_ad_types' ) ) {
    function wfnews_ad_types()
    {
		include(dirname(__FILE__).'/../adsense/adsense-ad-types.php');
		$type_options = array();
		foreach($ad_types as $type=>$values){
			$type_options[$type] = $values['key'];
		}		

        return $type_options;
    }
}
/******************
Post Categories List
******************/
if ( ! function_exists( 'wfnews_post_categories' ) ) {
    function wfnews_post_categories()
    {
        $wfnews_categories = array();
        $post_categories = get_categories(array(
            'hide_empty' => false
        ));
        if (is_array($post_categories) || is_object($post_categories)) {
            foreach ($post_categories as $category) {
                $wfnews_categories[$category->name] = $category->term_id;
            }
        }
        return $wfnews_categories;
    }
}
/******************
Post Categories List By ID
******************/
if ( ! function_exists( 'wfnews_post_categories_ID' ) ) {
    function wfnews_post_categories_ID()
    {
        $wfnews_categories = array();
        $post_categories = get_categories(array(
            'hide_empty' => false
        ));
        if (is_array($post_categories) || is_object($post_categories)) {
            foreach ($post_categories as $category) {
                $wfnews_categories[$category->name] = $category->term_id;
                //$wfnews_categories[$category->name] = $category->cat_ID;
            }
        }
        return $wfnews_categories;
    }
}
/******************
Default category name
******************/
if ( ! function_exists( 'wfnews_default_category' ) ) {
    function wfnews_default_category()
    {
        $categories = get_the_category();
        $default_category = array();
        if (!empty($categories)) {
            $default_category = $categories[0]->term_id;
        }
        return $default_category;
    }
}

	//********************************//
    // GOOGLE FONTS  FUNCTIONS // 
    //********************************//
     
    // Build the string of values in an Array
if ( ! function_exists( 'wfnews_getFontsData' ) ) {	
     function wfnews_getFontsData( $fontsString ) {   
     
        // Font data Extraction
        $googleFontsParam = new Vc_Google_Fonts();      
        $fieldSettings = array();
        $fontsData = strlen( $fontsString ) > 0 ? $googleFontsParam->_vc_google_fonts_parse_attributes( $fieldSettings, $fontsString ) : '';
        return $fontsData;
         
    }
}     
    // Build the inline style starting from the data
if ( ! function_exists( 'wfnews_googleFontsStyles' ) ) {		
     function wfnews_googleFontsStyles( $fontsData ) {
         
        // Inline styles
        $fontFamily = explode( ':', $fontsData['values']['font_family'] );
        $styles[] = 'font-family:' . $fontFamily[0];
		if($fontsData['values']['font_style']){
        $fontStyles = explode( ':', $fontsData['values']['font_style'] );
        $styles[] = 'font-weight:' . $fontStyles[1];
        $styles[] = 'font-style:' . $fontStyles[2];
        } 
        $inline_style = '';     
        foreach( $styles as $attribute ){           
            $inline_style .= $attribute.'; ';       
        }   
         
        return $inline_style;
         
    }
}     
    // Enqueue right google font from Googleapis
if ( ! function_exists( 'wfnews_enqueueGoogleFonts' ) ) {		
     function wfnews_enqueueGoogleFonts( $fontsData ) {
         
        // Get extra subsets for settings (latin/cyrillic/etc)
        $settings = get_option( 'wpb_js_google_fonts_subsets' );
        if ( is_array( $settings ) && ! empty( $settings ) ) {
            $subsets = '&subset=' . implode( ',', $settings );
        } else {
            $subsets = '';
        }
         
        // We also need to enqueue font from googleapis
        if ( isset( $fontsData['values']['font_family'] ) ) {
            wp_enqueue_style( 
                'vc_google_fonts_' . vc_build_safe_css_class( $fontsData['values']['font_family'] ), 
                '//fonts.googleapis.com/css?family=' . $fontsData['values']['font_family'] . $subsets
            );
        }
         
    }
}
/**************************
 End Function Google Fonts 
***************************/
#-----------------------------------------------------------------
# Modifying wfnews_wp_is_mobile function of WordPress
#-----------------------------------------------------------------
if ( ! function_exists( 'wfnews_wp_is_mobile' ) ) {
    function wfnews_wp_is_mobile()
    {
        $classes = get_body_class();
        static $is_mobile;
        if (empty($_SERVER['HTTP_USER_AGENT'])) {
            $is_mobile = false;
        } elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'Mobile') !== false // many mobile devices (all iPhone, iPad, etc.)
            || strpos($_SERVER['HTTP_USER_AGENT'], 'Android') !== false
            || strpos($_SERVER['HTTP_USER_AGENT'], 'Silk/') !== false
            || strpos($_SERVER['HTTP_USER_AGENT'], 'Kindle') !== false
            || strpos($_SERVER['HTTP_USER_AGENT'], 'BlackBerry') !== false
            || strpos($_SERVER['HTTP_USER_AGENT'], 'Opera Mini') !== false
            || strpos($_SERVER['HTTP_USER_AGENT'], 'Opera Mobi') !== false
        ) {
            if (in_array('width_less_than_768', $classes)) {
                $is_mobile = false;
            } else {
                $is_mobile = false;
            }
        } else {
            $is_mobile = false;
        }
        return $is_mobile;
    }
}

// **********************************************************************//
// ! Excerpt and Content Limit
// **********************************************************************//
if ( ! function_exists( 'wfnews_excerpt' ) ) {
    function wfnews_excerpt($wordlimit)
    {
        $excerpt = explode(' ', get_the_excerpt(), $wordlimit);

        if (count($excerpt) >= $wordlimit) {
            array_pop($excerpt);
            $excerpt = implode(" ", $excerpt) . '...';
        } else {
            $excerpt = implode(" ", $excerpt);
        }

        $excerpt = preg_replace('`\[[^\]]*\]`', '', $excerpt);

        return $excerpt;
    }
}

// **********************************************************************//
// ! Category Styling Function
// **********************************************************************//
if ( ! function_exists( 'wfnews_all_category_styles' ) ) {
    function wfnews_all_category_styles( $sep = '', $echo = TRUE ) {

        if ( get_post_type() == 'post' ) {

            $output = ''; // temporary

            $category_code = array(); // temporary

            $cats = get_the_category();
            if ( ! empty($cats) && is_array($cats) ) {
                    foreach ( $cats as $cat_id => $cat ) {
                        if ( ! empty($cat) && is_array($cat) ) {
                            $cat_color = get_term_meta( $cat->cat_ID, '_category_color', true );
                        } else {
                            $cat_color = '';
                        }
                        $category_code[] = '<span style="background-color: #'.$cat_color.';" class="small-title-no-vc cat term-' . $cat->cat_ID . '"><a href="' . esc_url( get_category_link( $cat ) ) . '">' . esc_attr( $cat->name ) . '</a></span>';
                    }

                $output .= implode( $sep, $category_code );
                return $output;
            }else{
                return $output;
            }
        }
    }
}


if ( ! function_exists( 'wfnews_category_styles' ) ) {
    function wfnews_category_styles( $sep = '', $echo = TRUE ) {

        if ( get_post_type() == 'post' ) {

            $output = ''; // temporary

            $category_code = array(); // temporary

            $cats = get_the_category();
            if ( ! empty($cats) && is_array($cats) ) {
                    if ( $cats[0] ) {
                        if ( ! empty($cats[0]) && is_array($cats[0]) ) {
                            $cat_color = get_term_meta( $cats[0]->cat_ID, '_category_color', true );
                        } else {
                            $cat_color = '';
                        }

                        $category_code[] = '<span style="background-color: #'.$cat_color.';" class="small-title-no-vc cat term-' . $cats[0]->cat_ID . '"><a href="' . esc_url( get_category_link( $cats[0]->term_id ) ) . '">' . esc_attr( $cats[0]->cat_name ) . '</a></span>';

                    } else {
                        $category_code[] = '';
                    }

                $output .= implode( $sep, $category_code );
                return $output; // escaped before already
            }else{
                return $output;
            }
        }
    }
}
/*Preview CSS*/
function wfnews_preview_styles() {
if(wfnews_get_plugin_option('shortcode_preview_settings')== "on"){ ?>
<style id="wfnews_preview_styles">
.wfnewsallinfo a.clckhr{color:#fff !important;text-decoration:underline !important;font-size:15px;text-transform:capitalize;}
.wfnewsallinfo a.clckhr:hover{color:#f43d2a !important;}
.beforegeneralstyle,.beforethumbnail400,.beforethumbnail210,.beforethumbnail243,.beforethumbnail335,.beforethumbnail148,.beforethumbnail460,.beforethumbnail477.sdfwa,.beforethumbnail172,.beforeanotherstyle3,.beforeanotherstyle4,.beforeanotherstyle5,.beforeonecollargestyle{position:relative;-webkit-transition:all 0.35s ease-in-out;-moz-transition:all 0.35s ease-in-out;transition:all 0.35s ease-in-out;cursor: default;}
.beforegeneralstyle *,.beforethumbnail210 *,.beforethumbnail243 *,.beforethumbnail335 *,.beforethumbnail148 *,.beforethumbnail460 *,.beforethumbnail477.sdfwa *,.beforethumbnail172 *,.beforeanotherstyle3 *,.beforeanotherstyle4 *,.beforeanotherstyle5 *,.beforeonecollargestyle *{-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;}
.generalstyle:before,.thumbnail400:before,.thumbnail210:before,.thumbnail243:before,.thumbnail148:before,.thumbnail335:before,.thumbnail460:before,.beforethumbnail477.bg-img:before,.thumbnail172:before,.anotherstyle3:before,.anotherstyle4:before,.anotherstyle5:before,.onecollargestyle:before{position:absolute;display:block;content:'';width:100%;height:100%;-webkit-transition:all 0.35s ease-in-out;-moz-transition:all 0.35s ease-in-out;transition:all 0.35s ease-in-out;}
.beforegeneralstyle .wfnewsallinfo,.beforethumbnail400 .wfnewsallinfo,.beforethumbnail210 .wfnewsallinfo,.beforethumbnail243 .wfnewsallinfo,.beforethumbnail335 .wfnewsallinfo,.beforethumbnail148 .wfnewsallinfo,.beforethumbnail460 .wfnewsallinfo,.beforethumbnail477.sdfwa .wfnewsallinfo,.beforethumbnail172 .wfnewsallinfo,.beforeanotherstyle3 .wfnewsallinfo,.beforeanotherstyle4 .wfnewsallinfo,.beforeanotherstyle5 .wfnewsallinfo,.beforeonecollargestyle .wfnewsallinfo{position:absolute;top:0;bottom:0;left:0;right:0;text-align:center;-webkit-backface-visibility:hidden;backface-visibility:hidden;}
.beforegeneralstyle .wfnewsallinfo a,.beforethumbnail400 .wfnewsallinfo a,.beforethumbnail210 .wfnewsallinfo a,.beforethumbnail243 .wfnewsallinfo a,.beforethumbnail335 .wfnewsallinfo a,.beforethumbnail148 .wfnewsallinfo a,.beforethumbnail460 .wfnewsallinfo a,.beforethumbnail477.sdfwa .wfnewsallinfo a,.beforethumbnail172 .wfnewsallinfo a,.beforeanotherstyle3 .wfnewsallinfo a,.beforeanotherstyle4 .wfnewsallinfo a,.beforeanotherstyle5 .wfnewsallinfo a,.beforeonecollargestyle .wfnewsallinfo a{cursor: pointer;}
.generalstyle,.thumbnail400,.thumbnail210,.thumbnail243,.thumbnail148,.thumbnail335,.thumbnail460,.beforethumbnail477.bg-img,.thumbnail172,.anotherstyle3,.anotherstyle4,.anotherstyle5,.onecollargestyle{width:100%;height:100%;opacity:1;-webkit-transform:scale(1);-moz-transform:scale(1);-ms-transform:scale(1);-o-transform:scale(1);transform:scale(1);-webkit-transition:all 0.35s ease-in-out;-moz-transition:all 0.35s ease-in-out;transition:all 0.35s ease-in-out;}
.beforegeneralstyle .wfnewsallinfo,.beforethumbnail400 .wfnewsallinfo,.beforethumbnail210 .wfnewsallinfo,.beforethumbnail243 .wfnewsallinfo,.beforethumbnail335 .wfnewsallinfo,.beforethumbnail148 .wfnewsallinfo,.beforethumbnail460 .wfnewsallinfo,.beforethumbnail477.sdfwa .wfnewsallinfo,.beforethumbnail172 .wfnewsallinfo,.beforeanotherstyle3 .wfnewsallinfo,.beforeanotherstyle4 .wfnewsallinfo,.beforeanotherstyle5 .wfnewsallinfo,.beforeonecollargestyle .wfnewsallinfo{background:#333333;background:rgba(0, 0, 0, 0.6);opacity:0;-webkit-transition:all 0.35s ease-in-out;-moz-transition:all 0.35s ease-in-out;transition:all 0.35s ease-in-out;}
.beforegeneralstyle .wfnewsallinfo h3,.beforethumbnail400 .wfnewsallinfo h3,.beforethumbnail210 .wfnewsallinfo h3,.beforethumbnail243 .wfnewsallinfo h3,.beforethumbnail335 .wfnewsallinfo h3,.beforethumbnail148 .wfnewsallinfo h3,.beforethumbnail460 .wfnewsallinfo h3,.beforethumbnail477.sdfwa .wfnewsallinfo h3,.beforethumbnail172 .wfnewsallinfo h3,.beforeanotherstyle3 .wfnewsallinfo h3,.beforeanotherstyle4 .wfnewsallinfo h3,.beforeanotherstyle5 .wfnewsallinfo h3,.beforeonecollargestyle .wfnewsallinfo h3{color:#fff;text-transform:uppercase;position:relative;letter-spacing:1px;font-size:18px;margin:0 30px;padding:36px 0 0 0;height:75px;text-shadow:0 0 1px white, 0 1px 2px rgba(0, 0, 0, 0.3);}
.beforethumbnail148 .wfnewsallinfo h3,.beforethumbnail172 .wfnewsallinfo h3{letter-spacing: 0;font-size: 13px;margin: 0 20px;padding: 18px 0 0 0;height: 50px;}
.beforegeneralstyle .wfnewsallinfo p,.beforethumbnail400 .wfnewsallinfo p,.beforethumbnail210 .wfnewsallinfo p,.beforethumbnail243 .wfnewsallinfo p,.beforethumbnail335 .wfnewsallinfo p,.beforethumbnail148 .wfnewsallinfo p,.beforethumbnail460 .wfnewsallinfo p,.beforethumbnail477.sdfwa .wfnewsallinfo p,.beforethumbnail172 .wfnewsallinfo p,.beforeanotherstyle3 .wfnewsallinfo p,.beforeanotherstyle4 .wfnewsallinfo p,.beforeanotherstyle5 .wfnewsallinfo p,.beforeonecollargestyle .wfnewsallinfo p{color:#fafafa !important;padding:10px 5px;margin:0 30px;font-size:14px;border-top:1px solid rgba(255, 255, 255, 0.5);}
.beforethumbnail148 .wfnewsallinfo p,.beforethumbnail172 .wfnewsallinfo p{padding: 5px 5px;margin: 0 15px;font-size: 12px;}
.beforegeneralstyle:hover .wfnewsallinfo,.beforethumbnail400:hover .wfnewsallinfo,.beforethumbnail210:hover .wfnewsallinfo,.beforethumbnail243:hover .wfnewsallinfo,.beforethumbnail335:hover .wfnewsallinfo,.beforethumbnail148:hover .wfnewsallinfo,.beforethumbnail460:hover .wfnewsallinfo,.beforethumbnail477.sdfwa:hover .wfnewsallinfo,.beforethumbnail172:hover .wfnewsallinfo,.beforeanotherstyle3:hover .wfnewsallinfo,.beforeanotherstyle4:hover .wfnewsallinfo,.beforeanotherstyle5:hover .wfnewsallinfo,.beforeonecollargestyle:hover .wfnewsallinfo{opacity:1;-webkit-transform:translateY(0);-moz-transform:translateY(0);-ms-transform:translateY(0);-o-transform:translateY(0);transform:translateY(0);}
.beforethumbnail210 .wfnewsallinfo h3{padding: 25px 0 0 0;height: 55px;}
</style>
<?php }
}
add_action( 'wp_head', 'wfnews_preview_styles', 150 );

/******************
Post Types List
******************/
if ( ! function_exists( 'wfnews_post_types' ) ) {
    function wfnews_post_types()
    {
	$wfnews_types=array();
	$args = array();
	$output = 'names'; // names or objects
	$post_types = get_post_types( $args, $output ,$operator = 'and');
	foreach ( $post_types  as $post_type ) {
	    $wfnews_types[]= $post_type;
	}
	return $wfnews_types;
	}
}

/******************
Post Types Taxonomy
******************/
if ( ! function_exists( 'wfnews_post_types_taxonomy' ) ) {
    function wfnews_post_types_taxonomy()
    {	
	$wfnews_types_taxonomy=array();
	$taxonomys = get_terms();//custom category name 
	foreach ( $taxonomys  as $taxonomy ) {
	    $wfnews_types_taxonomy[$taxonomy->name]= $taxonomy->term_id;
	}
	return $wfnews_types_taxonomy;
	}
}