<?php
add_action( 'load-widgets.php', 'wfnews_custom_load' );

function wfnews_custom_load() {    
    wp_enqueue_style( 'wp-color-picker' );        
    wp_enqueue_script( 'wp-color-picker' );    
}

/*************************
Start Popular Post widget
*************************/
class wfnews_popular_posts_widget extends WP_Widget {

  function __construct() {
    parent::__construct(
      'wfnews_popular_posts', // Base ID
      esc_html__('WFNews Popular Posts', 'wfnews'), // Name
      array( 'description' => esc_html__( 'Displays WFNews Popular Posts', 'wfnews'), ) // Args
    );
  }


      /*-------------------------------------------------------
       *        Front-end display of widget
       *-------------------------------------------------------*/


  public function widget( $args, $instance ) {
	  extract($args);
      $title = isset($instance['title']) ? $instance['title'] : '';
	  $certain_cat = isset($instance['certain_cat']) ? $instance['certain_cat'] : '';
	  $post_limit = isset($instance['post_limit']) ? $instance['post_limit'] : '';
	  $wordcount = isset($instance['wordcount']) ? $instance['wordcount'] : '';
	  $load_more = isset($instance['load_more']) ? $instance['load_more'] : '';
	  $popularposts_widget_title_color = isset($instance['popularposts_widget_title_color']) ? $instance['popularposts_widget_title_color'] : '';
	  $popularposts_widget_title_background_color = isset($instance['popularposts_widget_title_background_color']) ? $instance['popularposts_widget_title_background_color'] : '';
      $margintop = isset($instance['margintop']) ? $instance['margintop'] : '';
	  $marginbottom = isset($instance['marginbottom']) ? $instance['marginbottom'] : '';
      $current_time = isset($instance['current_time']) ? $instance['current_time'] : '';
      $width = isset($instance['width']) ? $instance['width'] : '';
      $height = isset($instance['height']) ? $instance['height'] : '';
      $title_font_size = isset($instance['title_font_size']) ? $instance['title_font_size'] : '';
      $title_line_height = isset($instance['title_line_height']) ? $instance['title_line_height'] : '';
      $date_meta_switch = isset($instance['date_meta_switch']) ? $instance['date_meta_switch'] : '';
	  $comment_meta_switch = isset($instance['comment_meta_switch']) ? $instance['comment_meta_switch'] : '';
	  $heading_style = isset($instance['heading_style']) ? $instance['heading_style'] : '';
	  	
	  $heading_border_color = isset($instance['heading_border_color']) ? $instance['heading_border_color'] : '';
	  $meta_color = isset($instance['meta_color']) ? $instance['meta_color'] : '';
	  $title_color = isset($instance['title_color']) ? $instance['title_color'] : '';
	  $title_hover_color = isset($instance['title_color']) ? $instance['title_hover_color'] : '';
	  $button_bg = isset($instance['button_bg']) ? $instance['button_bg'] : '';
	  $button_hover_bg = isset($instance['button_hover_bg']) ? $instance['button_hover_bg'] : '';
	  $heading_font_weight = isset($instance['heading_font_weight']) ? $instance['heading_font_weight'] : '';
	  $block_border_color = isset($instance['block_border_color']) ? $instance['block_border_color'] : '';
	  $block_padding = isset($instance['block_padding']) ? $instance['block_padding'] : '';
	  
	if($width){
		$width=$width;
	}else{
		$width='80px';
	} 
	if($height){
		$height=$height;
	}else{
		$height='80px';
	} 
 
  $before_widget = $args['before_widget'];
  $after_widget = $args['after_widget'];
  
  $marginstyle = '';
  if(($margintop != '') || ($marginbottom != '')){
  $marginstyle ='style="';
  if($margintop != ''){
  $marginstyle .='margin-top:'.esc_attr($margintop).';';
  } if($marginbottom != ''){
  $marginstyle .='margin-bottom:'.esc_attr($marginbottom).';';
  }
  $marginstyle .='"';
  }

  $before_widget = str_replace('class="', ''. $marginstyle . ' class="', $before_widget);

	// generate unique class for the section	
	for($i=0;$i<=50;$i++){
		$str = 'abcdefghijk';
		$shuffled = str_shuffle($str);
	}
	$unique_css_class=$shuffled;
		
	
	 $style='';
		// style wise css headline css include
		if($heading_style == "style1") {
			include(dirname(__FILE__).'/../css/title/title-style1.php');
		}elseif ($heading_style == "style2"){
			include(dirname(__FILE__).'/../css/title/title-style2.php');
		}elseif ($heading_style == "style3"){
			include(dirname(__FILE__).'/../css/title/title-style3.php');
		}elseif ($heading_style == "style4"){
			include(dirname(__FILE__).'/../css/title/title-style4.php');
		}elseif ($heading_style == "style5"){
			include(dirname(__FILE__).'/../css/title/title-style5.php');
		}elseif ($heading_style == "style6"){
			include(dirname(__FILE__).'/../css/title/title-style6.php');
		}elseif ($heading_style == "style7"){
			include(dirname(__FILE__).'/../css/title/title-style7.php');
		}elseif ($heading_style == "style8"){
			include(dirname(__FILE__).'/../css/title/title-style8.php');
		}elseif ($heading_style == "style9"){
			include(dirname(__FILE__).'/../css/title/title-style9.php');
		}elseif ($heading_style == "style10"){
			include(dirname(__FILE__).'/../css/title/title-style10.php');
		}elseif ($heading_style == "style11"){
			include(dirname(__FILE__).'/../css/title/title-style11.php');
		}elseif ($heading_style == "style12"){
			include(dirname(__FILE__).'/../css/title/title-style12.php');
		}elseif ($heading_style == "style13"){
			include(dirname(__FILE__).'/../css/title/title-style13.php');
		}
		if($popularposts_widget_title_color){
		$style.= "
		<style>
		.post-block.".$unique_css_class." h4.margin-bottom-15 b{
			color: ".$popularposts_widget_title_color." !important;
		}
		</style>
		";	
		}
		if($popularposts_widget_title_background_color){
		$style.= "
		<style>
		.post-block.".$unique_css_class." h4.margin-bottom-15{
			background-color: ".$popularposts_widget_title_background_color." !important;
		}
		</style>
		";	
		}
		if($meta_color){
		$style.= "
		<style>
		.post-block.".$unique_css_class." .meta{
			color: ".$meta_color." ;
		}
		</style>
		";	
		}
		if($title_color){
		$style.= "
		<style>
		.post-block.".$unique_css_class." h5.title a{
			color: ".$title_color." ;
		}
		</style>
		";	
		}
		if($title_hover_color){
		$style.= "
		<style>
		.post-block.".$unique_css_class." h5.title a:hover{
			color: ".$title_hover_color." ;
		}
		</style>
		";	
		}
		if($button_bg){
		$style.= "
		<style>
		.post-block.".$unique_css_class." .loadmorebtn{
			background-color: ".$button_bg.";
		}
		</style>
		";	
		}
		if($button_hover_bg){
		$style.= "
		<style>
		.post-block.".$unique_css_class." .loadmorebtn:hover{
			background-color: ".$button_hover_bg." !important;
		}
		</style>
		";	
		}
		if($heading_font_weight){
		$style.= "
		<style>
		.post-block.".$unique_css_class." h4.margin-bottom-15 b{
			font-weight: ".$heading_font_weight." !important;
		}
		</style>
		";	
		}
		if($block_border_color){
		$style.= "
		<style>
		.post-block.".$unique_css_class."{
			border:1px solid ".$block_border_color." ;
		}
		</style>
		";	
		}
		if($block_padding){
		$style.= "
		<style>
		.post-block.".$unique_css_class."{
			padding:".$block_padding." ;
		}
		</style>
		";	
		}
		
	$style_allowed_html_array = array(
				'div' => array(
					'class' => array(),
					'id' => array(),
					'style' => array()
				),
				'style' => array(
					'span' => array(),
					'style' => array()
				)
				);

	echo wp_kses($style, $style_allowed_html_array);
	echo $before_widget; //escaped already
  ?>
  <div class="side-widget popularposts<?php echo esc_attr($current_time); ?> post-block <?php echo esc_attr($unique_css_class); ?>">
  <?php if($title){ ?>
  <h4 class="margin-bottom-15"><b><?php echo esc_attr($title); ?></b></h4>
  <?php } ?>
	<div class="popular-posts<?php echo esc_attr($current_time); ?> mini-posts">
  <?php
	global $wp_query;		
	$temp_query = $wp_query;
	$wp_query= null;			
	$wp_query = new WP_Query( array('cat' => $certain_cat, 'posts_per_page' => $post_limit, 'ignore_sticky_posts' => 1, 'paged' => 1, 'orderby' => 'comment_count')); 
	
	$recent_post_num = 1;
	$video_allowed_html_array = array(
				'div' => array(
					'class' => array(),
					'id' => array(),
					'style' => array()
				),
				'img' => array(
					'class' => array(),
					'src' => array(),
					'alt' => array(),
					'style' => array()
				),
				'a' => array(
					'class' => array(),
					'href' => array(),
					'title' => array()
				));
	while ($wp_query->have_posts()) : $wp_query->the_post(); 
	$featured_img = esc_url( wp_get_attachment_url( get_post_thumbnail_id(get_the_ID()) ) ); 
	if($featured_img){
		if ( wfnews_wp_is_mobile() ) {
		$comment_post_get_image = get_the_post_thumbnail_url(get_the_ID(),'thumbnail');
		} else {
		$comment_post_get_image = get_the_post_thumbnail_url(get_the_ID(),'full');
		}
	}else{
		$comment_post_get_image = WFNEWS_IMAGE_DIR .'noblogimg.png';
	}
	if ( has_post_format( 'video' ) ) : 
						$videoicon = '<div class="play_thumb_48" style="background:none;"><a href="'.get_permalink().'"><img src="'. esc_url(WFNEWS_IMAGE_DIR) .'video.png" alt="" style="width:36px;height:36px;" /></a></div>';
					else:
						$videoicon = '';
					endif;
	?>
	<article class="style2 mb-3">
		<div class="row">
			<div class="col-md-4 col-sm-4">
				<?php echo wp_kses($videoicon, $video_allowed_html_array); ?>
				<a href="<?php the_permalink(); ?>">
					<div class="beforethumbnail">
						<div class="thumbnail bg-img" style="background-image: url(<?php echo esc_url($comment_post_get_image); ?>); opacity: 1;width:<?php if($width){ echo esc_attr($width) ; } ?>;height:<?php if($height){ echo esc_attr($height) ; } ?>;"></div>
					</div>
				</a>
			</div>
			<div class="col-md-8 col-sm-8">
				<div class="post-excerpt no-padding">
				 <?php if($date_meta_switch == 1){ ?>
					<div class="meta">
						<span><?php the_time(get_option('date_format')); ?></span>
					</div>
				 <?php } ?>	
					<h5 class="title" style="<?php if($title_font_size){ echo "font-size:".esc_attr($title_font_size).";" ; } ?>"><a href="<?php the_permalink(); ?>" style="<?php if($title_font_size){ echo "font-size:".esc_attr($title_font_size).";" ; } ?><?php if($title_line_height){ echo "line-height:".esc_attr($title_line_height).";" ; } ?>"><?php if ($wordcount != '') { echo wp_html_excerpt (get_the_title(), $wordcount); } else { echo get_the_title(); } ?></a></h5>
					<?php if(get_comments_number()>0){ ?>
					<?php if($comment_meta_switch ==1){ ?>
					<div class="meta">
						<span class="comment">
						<a href="<?php the_permalink(); ?>"><i class="far fa-comment"></i> <?php echo get_comments_number(); ?></a>
						</span>
					</div>
					<?php } ?>
					<?php } ?>
				</div>
			</div>
		</div>
	</article>
	<?php 
	endwhile;
	$wp_query = null;
	$wp_query = $temp_query;
	wp_reset_query();	
	?>
	</div>
	<?php if($instance['load_more']==1){ ?>
	<div class="popular_posts_loadmore<?php echo esc_attr($current_time); ?> loadmorebtn"><?php esc_html_e('Load More', 'wfnews'); ?> <i class="fas fa-redo" aria-hidden="true"></i></div>
	<script type="text/javascript">
	var ajaxurl = "<?php echo admin_url( 'admin-ajax.php' ); ?>";
	//var page = 2;
	var ppp = 2;
	var width = '<?php echo esc_attr($width); ?>';
	var height = '<?php echo esc_attr($height); ?>';
	var title_font_size = '<?php echo esc_attr($title_font_size); ?>';
	var title_line_height = '<?php echo esc_attr($title_line_height); ?>';
	var date_meta_switch = '<?php echo esc_attr($date_meta_switch); ?>';
	var comment_meta_switch = '<?php echo esc_attr($comment_meta_switch); ?>';
	var preoffset = jQuery('.popular-posts<?php echo esc_attr($current_time); ?>').find('article').length;
	var offset = preoffset + 1;
	jQuery(function($) {
	$('body').on('click', '.popular_posts_loadmore<?php echo esc_attr($current_time); ?>', function() {
		var data = {
			'action': 'load_popular_posts_by_ajax_2',
			//'page': page,
			'ppp': ppp,
			'offset': offset,
			'width': width,
			'height': height ,
			'date_meta_switch': date_meta_switch ,
			'comment_meta_switch': comment_meta_switch ,
			'title_font_size': title_font_size ,
			'title_line_height': title_line_height ,
			'security': '<?php echo wp_create_nonce("load_more_popular_posts"); ?>'
		};
		$(".popular_posts_loadmore<?php echo esc_attr($current_time); ?>.loadmorebtn i").addClass("fa-spin");

		$.post(ajaxurl, data, function(response) {
			if(response != '') {
			$('.popular-posts<?php echo esc_attr($current_time); ?>').append(response);
			ppp++;
			$(".popular_posts_loadmore<?php echo esc_attr($current_time); ?>.loadmorebtn i").removeClass("fa-spin");
			} else {
			$('.popular_posts_loadmore<?php echo esc_attr($current_time); ?>').hide();
			}
		});
		offset = offset + ppp;
		return false;
	});
	});
	</script>
	<?php } ?>
	</div>
	<?php echo $after_widget; //escaped already ?>

	<div class="clearfix"></div>
	<?php
  }
  
  
  function update( $new_instance, $old_instance ){

    $instance = $old_instance;
    $instance['title']                = strip_tags( $new_instance['title'] );
    $instance['certain_cat']            = strip_tags( $new_instance['certain_cat'] );
	$instance['post_limit']            = strip_tags( $new_instance['post_limit'] );
	$instance['wordcount']            = strip_tags( $new_instance['wordcount'] );
    $instance['load_more']            = strip_tags( $new_instance['load_more'] );
	$instance['popularposts_widget_title_color'] = $new_instance['popularposts_widget_title_color'];
    $instance['popularposts_widget_title_background_color'] =  $new_instance['popularposts_widget_title_background_color'];
    $instance['margintop']            = strip_tags( $new_instance['margintop'] );
    $instance['marginbottom']            = strip_tags( $new_instance['marginbottom'] );
    $instance['current_time']            = strip_tags( $new_instance['current_time'] );
    $instance['width']            = strip_tags( $new_instance['width'] );
    $instance['height']            = strip_tags( $new_instance['height'] );
    $instance['title_font_size']            = strip_tags( $new_instance['title_font_size'] );
    $instance['title_line_height']            = strip_tags( $new_instance['title_line_height'] );
    $instance['date_meta_switch']            = strip_tags( $new_instance['date_meta_switch'] );
    $instance['comment_meta_switch']            = strip_tags( $new_instance['comment_meta_switch'] );
    $instance['heading_style']            = strip_tags( $new_instance['heading_style'] );
    $instance['heading_border_color'] = $new_instance['heading_border_color'] ;
    $instance['meta_color'] = $new_instance['meta_color'] ;
    $instance['title_color'] = $new_instance['title_color'] ;
    $instance['title_hover_color'] = $new_instance['title_hover_color'] ;
    $instance['button_bg'] = $new_instance['button_bg'] ;
    $instance['button_hover_bg'] = $new_instance['button_hover_bg'] ;
    $instance['heading_font_weight'] = $new_instance['heading_font_weight'] ;
    $instance['block_border_color'] = $new_instance['block_border_color'] ;
    $instance['block_padding'] = $new_instance['block_padding'] ;
    return $instance;

  }


  function form($instance){
    $defaults = array( 
      'title'               => '',
	  'certain_cat'           => 1,
      'post_limit'           => '',
	  'wordcount'           => '',
      'load_more'           => 0,
	  'popularposts_widget_title_color'     => '',
	  'popularposts_widget_title_background_color'     => '',
      'margintop'           => '',
      'marginbottom'           => '',
      'current_time'           => time(),
      'width'           => '',
      'height'           => '',
      'title_font_size'           => '',
      'title_line_height'           => '',
      'date_meta_switch'           => 0,
      'comment_meta_switch'           => 0,
      'heading_style'           => '',
      'heading_border_color'           => '',
      'meta_color'           => '',
      'title_color'           => '',
      'title_hover_color'           => '',
      'button_bg'           => '',
      'button_hover_bg'           => '',
      'heading_font_weight'           => '',
      'block_border_color'           => '',
      'block_padding'           => '',
    );
    $instance = wp_parse_args( (array) $instance, $defaults );
  ?>
    <p>
      <label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php esc_html_e('Heading', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" class="widefat" value="<?php echo esc_attr($instance['title']); ?>">
    </p>
	<p>
	<select id="<?php echo esc_attr($this->get_field_id('heading_style')); ?>" name="<?php echo esc_attr($this->get_field_name('heading_style')); ?>" class="widefat" >
		<option <?php selected( $instance['heading_style'], 'style1'); ?> value="style1"><?php esc_html_e('Style 1', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style2'); ?> value="style2"><?php esc_html_e('Style 2', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style3'); ?> value="style3"><?php esc_html_e('Style 3', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style4'); ?> value="style4"><?php esc_html_e('Style 4', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style5'); ?> value="style5"><?php esc_html_e('Style 5', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style6'); ?> value="style6"><?php esc_html_e('Style 6', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style7'); ?> value="style7"><?php esc_html_e('Style 7', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style8'); ?> value="style8"><?php esc_html_e('Style 8', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style9'); ?> value="style9"><?php esc_html_e('Style 9', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style10'); ?> value="style10"><?php esc_html_e('Style 10', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style11'); ?> value="style11"><?php esc_html_e('Style 11', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style12'); ?> value="style12"><?php esc_html_e('Style 12', 'wfnews'); ?></option>
		<option <?php selected( $instance['heading_style'], 'style13'); ?> value="style13"><?php esc_html_e('Style 13', 'wfnews'); ?></option>
  
	</select>	
	</p>
    <p>
	<select id="<?php echo esc_attr($this->get_field_id( 'certain_cat' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'certain_cat' )); ?>" class="widefat">
		  <option value=""><?php esc_html_e('Post Category', 'wfnews'); ?></option>
		  <?php 
		  $post_categories=get_categories();
		  foreach($post_categories as $category) { 
		  ?>
		  <option value="<?php echo esc_attr($category->cat_ID); ?>" <?php if($instance['certain_cat']==$category->cat_ID){ echo 'selected'; } ?>><?php echo esc_attr($category->name); ?></option>
		  <?php } ?>
	</select>
	</p>
	
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'post_limit' )); ?>"><?php esc_html_e('Post Limit', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'post_limit' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'post_limit' )); ?>" class="widefat" value="<?php echo esc_attr($instance['post_limit']); ?>">
    </p>
	
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'wordcount' )); ?>"><?php esc_html_e('Title Character Limit', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'wordcount' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'wordcount' )); ?>" class="widefat" value="<?php echo esc_attr($instance['wordcount']); ?>">
	  <?php esc_html_e('Input a number here. For example if you input 20 here, the title will show up to 20 character at front-end. Keep it empty if you do not want to limit the character of Post Title.', 'wfnews'); ?>
    </p>
		
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'load_more ' )); ?>"><?php esc_html_e('Do you want Load More?', 'wfnews'); ?></label><br/>
      <?php if($instance['load_more']==1){ ?>
	  <?php esc_html_e(' Yes ', 'wfnews'); ?><input type="checkbox" id="<?php echo esc_attr($this->get_field_id( 'load_more' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'load_more' )); ?>" class="widefat" value="<?php echo esc_attr($instance['load_more']); ?>" checked>
	  <?php }else{ ?>
	  <?php esc_html_e(' Yes ', 'wfnews'); ?><input type="checkbox" id="<?php echo esc_attr($this->get_field_id( 'load_more' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'load_more' )); ?>" class="widefat" value="<?php esc_html_e('1', 'wfnews');?>">
	  <?php } ?>
	</p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'date_meta_switch ' )); ?>"><?php esc_html_e('Do you want Date Meta?', 'wfnews'); ?></label><br/>
      <?php if($instance['date_meta_switch']==1){ ?>
	  <?php esc_html_e(' Yes ', 'wfnews'); ?><input type="checkbox" id="<?php echo esc_attr($this->get_field_id( 'date_meta_switch' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'date_meta_switch' )); ?>" class="widefat" value="<?php echo esc_attr($instance['date_meta_switch']); ?>" checked>
	  <?php }else{ ?>
	  <?php esc_html_e(' Yes ', 'wfnews'); ?><input type="checkbox" id="<?php echo esc_attr($this->get_field_id( 'date_meta_switch' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'date_meta_switch' )); ?>" class="widefat" value="<?php esc_html_e('1', 'wfnews');?>">
	  <?php } ?>
	</p>	
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'comment_meta_switch ' )); ?>"><?php esc_html_e('Do you want Comment Meta?', 'wfnews'); ?></label><br/>
      <?php if($instance['comment_meta_switch']==1){ ?>
	  <?php esc_html_e(' Yes ', 'wfnews'); ?><input type="checkbox" id="<?php echo esc_attr($this->get_field_id( 'comment_meta_switch' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'comment_meta_switch' )); ?>" class="widefat" value="<?php echo esc_attr($instance['comment_meta_switch']); ?>" checked>
	  <?php }else{ ?>
	  <?php esc_html_e(' Yes ', 'wfnews'); ?><input type="checkbox" id="<?php echo esc_attr($this->get_field_id( 'comment_meta_switch' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'comment_meta_switch' )); ?>" class="widefat" value="<?php esc_html_e('1', 'wfnews');?>">
	  <?php } ?>
	</p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'popularposts_widget_title_color ' )); ?>"><?php esc_html_e('Heading Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'popularposts_widget_title_color' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'popularposts_widget_title_color' )); ?>" class="widefat popularposts_widget_title_color" value="<?php echo esc_attr($instance['popularposts_widget_title_color']); ?>">
    </p>
	<script>
		jQuery(document).ready(function(jQuery){
			jQuery('.popularposts_widget_title_color').each(function(){
        		jQuery(this).wpColorPicker();
    		});
		});
		</script>	

	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'popularposts_widget_title_background_color ' )); ?>"><?php esc_html_e('Heading Background Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'popularposts_widget_title_background_color' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'popularposts_widget_title_background_color' )); ?>" class="widefat popularposts_widget_title_background_color" value="<?php echo esc_attr($instance['popularposts_widget_title_background_color']); ?>">
    </p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'heading_border_color' )); ?>"><?php esc_html_e('Headline Border Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'heading_border_color' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'heading_border_color' )); ?>" class="widefat heading_border_color" value="<?php echo esc_attr($instance['heading_border_color']); ?>">
    </p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'meta_color' )); ?>"><?php esc_html_e('Meta Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'meta_color' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'meta_color' )); ?>" class="widefat meta_color" value="<?php echo esc_attr($instance['meta_color']); ?>">
    </p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'title_color' )); ?>"><?php esc_html_e('Post Title Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'title_color' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title_color' )); ?>" class="widefat title_color" value="<?php echo esc_attr($instance['title_color']); ?>">
    </p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'title_hover_color' )); ?>"><?php esc_html_e('Post Title Hover Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'title_hover_color' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title_hover_color' )); ?>" class="widefat title_hover_color" value="<?php echo esc_attr($instance['title_hover_color']); ?>">
    </p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'button_bg' )); ?>"><?php esc_html_e('Button Background Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'button_bg' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'button_bg' )); ?>" class="widefat button_bg" value="<?php echo esc_attr($instance['button_bg']); ?>">
    </p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'button_hover_bg' )); ?>"><?php esc_html_e('Button Hover Background Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'button_hover_bg' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'button_hover_bg' )); ?>" class="widefat button_hover_bg" value="<?php echo esc_attr($instance['button_hover_bg']); ?>">
    </p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'block_border_color' )); ?>"><?php esc_html_e('Block Border Color', 'wfnews'); ?></label><br/>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'block_border_color' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'block_border_color' )); ?>" class="widefat block_border_color" value="<?php echo esc_attr($instance['block_border_color']); ?>">
    </p>	
	<script>
		jQuery(document).ready(function(jQuery){
			jQuery('.popularposts_widget_title_background_color').each(function(){
        		jQuery(this).wpColorPicker();
    		});
			jQuery('.heading_border_color').wpColorPicker();
			jQuery('.meta_color').wpColorPicker();
			jQuery('.title_color').wpColorPicker();
			jQuery('.title_hover_color').wpColorPicker();
			jQuery('.button_bg').wpColorPicker();
			jQuery('.button_hover_bg').wpColorPicker();
			jQuery('.block_border_color').wpColorPicker();
		});
	</script>	
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'margintop' )); ?>"><?php esc_html_e('Widget Margin Top', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'margintop' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'margintop' )); ?>" class="widefat" value="<?php echo esc_attr($instance['margintop']); ?>">
      <?php esc_html_e( 'Example: 10px', 'wfnews'); ?>
	</p>  
	
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'marginbottom ' )); ?>"><?php esc_html_e('Widget Margin Bottom', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'marginbottom' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'marginbottom' )); ?>" class="widefat" value="<?php echo esc_attr($instance['marginbottom']); ?>">
      <?php esc_html_e( 'Example: 10px', 'wfnews'); ?>
	</p>
		
	<input type="hidden" id="<?php echo esc_attr($this->get_field_id( 'current_time' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'current_time' )); ?>" class="widefat" value="<?php echo time(); ?>">
	
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'width' )); ?>"><?php esc_html_e('Thumbnail Width', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'width' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'width' )); ?>" class="widefat" value="<?php echo esc_attr($instance['width']); ?>">
      <?php esc_html_e( 'Example: 100px', 'wfnews'); ?>
	</p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'height' )); ?>"><?php esc_html_e('Thumbnail Height', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'height' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'height' )); ?>" class="widefat" value="<?php echo esc_attr($instance['height']); ?>">
      <?php esc_html_e( 'Example: 100px', 'wfnews'); ?>
	</p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'title_font_size' )); ?>"><?php esc_html_e('Post Title Font Size', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'title_font_size' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title_font_size' )); ?>" class="widefat" value="<?php echo esc_attr($instance['title_font_size']); ?>">
      <?php esc_html_e( 'Example: 10px', 'wfnews'); ?>
	</p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'title_line_height' )); ?>"><?php esc_html_e('Post Title Line Height', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'title_line_height' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title_line_height' )); ?>" class="widefat" value="<?php echo esc_attr($instance['title_line_height']); ?>">
      <?php esc_html_e( 'Example: 10px', 'wfnews'); ?>
	</p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'heading_font_weight' )); ?>"><?php esc_html_e('Headline Font Weight', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'heading_font_weight' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'heading_font_weight' )); ?>" class="widefat" value="<?php echo esc_attr($instance['heading_font_weight']); ?>">
      <?php esc_html_e( 'Example: 400', 'wfnews'); ?>
	</p>
	<p>
      <label for="<?php echo esc_attr($this->get_field_id( 'block_padding' )); ?>"><?php esc_html_e('Block Padding', 'wfnews'); ?></label>
      <input type="text" id="<?php echo esc_attr($this->get_field_id( 'block_padding' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'block_padding' )); ?>" class="widefat" value="<?php echo esc_attr($instance['block_padding']); ?>">
      <?php esc_html_e( 'Example: 10px', 'wfnews'); ?>
	</p>	
  <?php
  }

}//end of class

// register wfnews_popular_posts_widget widget
if ( ! function_exists( 'wfnews_register_popular_posts_Widget' ) ) {
function wfnews_register_popular_posts_Widget() {
  register_widget( 'wfnews_popular_posts_widget' );  // Class Name
}
}
add_action( 'widgets_init', 'wfnews_register_popular_posts_Widget' );